
set applications {"MIDAS Data Analysis" "MIDAS Data Acquisition" MIDASsort MTsort exogam megha charissa GREAT RISING Prisma \
    GRT TUDA TIARA Afrodite FERA S9418 CAEN HVANCIL HV TAS meis vxi vme camac laser theory user \
       "user application" "Httpd+SOAP" default}

proc select-application {which} {
  global env

  if {$env(platform) == "unix"} then {set J ":"} else {set J ";"}

  set debug 0
  set ll [split $which -]
  if {[last $ll] == "debug"} then {
    set debug 1
    set which [join [lreplace $ll end end] -]
  }

  set base $env(MIDASBASE)
  set core [file join $base MIDASsort tcl]$J[file join $base tcl]

  switch $which {

     "MIDAS Data Analysis" {
        set tclpath $core
     }

     "MIDAS Data Acquisition" {
        set tclpath [file join $base MIDAS_Acq tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J[file join $base MTsort tcl]$J$core
     }

     MTsort {
        set tclpath [file join $base MTsort tcl]$J[file join $base tcl]
     }

     MIDASsort {
        set tclpath $core
     }

     euroball {
        set tclpath [file join $base sbg tcl]$J[file join $base euroball tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J[file join $base camac tcl]$J$core
     }

     exogam {
        set tclpath [file join $base exogam tcl]$J[file join $base MTsort tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J$core
     }

     HV {
        set tclpath [file join $base highVoltage tcl]$J[file join $base tcl]
     }

     HVANCIL {
        set tclpath [file join $base highVoltage ANCIL tcl]$J[file join $base highVoltage tcl]$J[file join $base tcl]
     }

     megha {
        set tclpath [file join $base megha tcl]$J[file join $base fera tcl]$J[file join $base charissa tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J[file join $base camac tcl]$J$core
     }

     charissa {
        set tclpath [file join $base charissa tcl]$J[file join $base fera tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J[file join $base camac tcl]$J$core
     }

     Afrodite {
        set tclpath [file join $base Afrodite tcl]$J[file join $base fera tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J[file join $base camac tcl]$J[file join $base MTsort tcl]$J$core
     }

     TAS {
        set tclpath [file join $base TAS tcl]$J[file join $base fera tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J[file join $base camac tcl]$J[file join $base MTsort tcl]$J$core
     }

     FERA {
        set tclpath [file join $base fera tcl]$J[file join $base Data_Acq tcl]$J[file join $base camac tcl]$J[file join $base vme tcl]$J$core
     }

     S9418 {
        set tclpath [file join $base S9418 tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J$core
     }

     CAEN {
        set tclpath [file join $base CAEN tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J$core
     }

     TUDA {
        set tclpath [file join $base TUDA tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J$core
     }

     TIARA {
        set tclpath [file join $base TIARA tcl]$J[file join $base Data_Acq tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J$core
     }

     laser {
        set tclpath [file join $base laser tcl]$J[file join $base vme tcl]$J[file join $base tcl]
     }
     meis {
        set tclpath [file join $base meis tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J[file join $base tcl]

        if {$env(platform) == "windows"} then {
            set binext "_Win"
        } else {
            switch $env(os)  {
               SunOS   {set binext "_SunOS"}
               Linux   {set binext "_Linux"}
               default {set binext ""}
            }
        }
        set meispath [file join $base meis bin$binext]

        set env(PATH) $meispath$J$env(PATH)
        puts stdout "program search path now includes $meispath"
     }

     GREAT {
        set tclpath [file join $base GREAT tcl]$J[file join $base Data_Acq tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J[file join $base camac tcl]$J[file join $base highVoltage tcl]$J[file join $base tcl]
     }

     GREATEB {
        set tclpath [file join $base GREAT EventBuilder tcl]$J[file join $base MTsort tcl]$J[file join $base GREAT tcl]$J[file join $base Data_Acq tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J[file join $base camac tcl]$J[file join $base tcl]
        switch $env(os)  {
           SunOS   {
               set env(PATH) [file join $base GREAT EventBuilder bin_SunOS]:[file join $base MTsort bin_SunOS]:$env(PATH)
               set env(LD_LIBRARY_PATH) [file join $base GREAT EventBuilder lib_SunOS]:[file join $base MTsort lib_SunOS]:$env(LD_LIBRARY_PATH)
           }
           Linux   {
               set env(PATH) [file join $base GREAT EventBuilder bin_Linux]:[file join $base MTsort bin_Linux]:$env(PATH)
               set env(LD_LIBRARY_PATH) [file join $base GREAT EventBuilder lib_Linux]:[file join $base MTsort lib_Linux]:$env(LD_LIBRARY_PATH)
           }
           default {puts stderr "not available for platform $env(platform)"}
        }
     }

     RISING {
        set tclpath [file join $base RISING tcl]$J[file join $base Data_Acq tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J[file join $base tcl]
     }

     Prisma {
        set tclpath [file join $base Prisma tcl]$J[file join $base Data_Acq tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J[file join $base TclHttpd tcl]$J[file join $base SOAP tcl]$J$core
     }

     vxi {
        set tclpath [file join $base vxi tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J$core
     }

     vme {
        set tclpath [file join $base vme tcl]$J[file join $base Data_Acq tcl]$J$core
     }

     camac {
        set tclpath [file join $base camac tcl]$J[file join $base Data_Acq tcl]$J$core
     }
     
     CCCS {
        set tclpath [file join $base CCCS tcl]$J[file join $base vme tcl]$J[file join $base tcl]
     }

     ECR {
        set tclpath [file join $base ECR tcl]$J[file join $base vme tcl]$J[file join $base tcl]
     }
     
     GRT {
        set tclpath [file join $base GRT tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J[file join $base MTsort tcl]$J$core
     }

     theory {
        set tclpath [file join $base theory tcl]$J[file join $base tcl]
     }

     user {
        set tclpath [file join $env(HOME) tcl]$J[file join $base user tcl]$J[file join $base tcl]
     }

     "user application" {
        set tclpath [file join $env(HOME) MidasApplication tcl]$J[file join $base user tcl]$J[file join $base tcl]
     }

     "Httpd+SOAP" {
        set tclpath [file join $base TclHttpd tcl]$J[file join $base SOAP tcl]$J[file join $base tcl]
     }

     default {
        set tclpath $core
     }
  }

  if {$debug} then {
    set tclpath [file join $env(HOME) tcl]$J$tclpath
    puts stdout "Debugging $which"
  }

  set env(TCLPATH) $tclpath

}
