# Exception monitor---xm.tcl
#    Jan 1999  VP
#    New version suitable for 8.0 which does not use the msg programs
#    Now need access (NFS) to the log directory


set debug 0
set started 0

set frame XM
set frametitle "Exception Monitor"
set icontitle "Exceptions"

set xmdirectory "$env(MIDASXMBASE)"
set xmfile ""

set ActionEnable 0
set ActionLevel 9

set OpenPending ""

set xmstatus 0
set xmsize 0

set xmperiod 2500


set maxclass 43
# for {set i 0} {$i<=$maxclass} {incr i} {set selected($i) 1}
# set selected(0) 0

set classlist {1 2 3 4 5 6 7 8 9 10 12 19 20 21 40 41 42 43}

for {set i 0} {$i<=$maxclass} {incr i} {set selected($i) 0}
foreach i $classlist {set selected($i) 1}

set maxlevel 9
set min 3
set max 9

set classnames  [list "0  - Test"  \
	              "1  - Miscellaneous"  \
		      "2  - Autofill"  \
		      "3  - High Voltage"  \
                      "4  - Spectrum Server"  \
		      "5  - VXI"  \
		      "6  - Histogrammer"  \
		      "7  - Resource Manager"  \
		      "8  - Register Server"  \
		      "9  - Data Acquisition"  \
		      "10 - CAMAC"  \
		      "11 - unused"  \
		      "12 - Tape Server"  \
		      "13 - unused"  \
		      "14 - unused"  \
	              "15 - unused"  \
		      "16 - unused"  \
		      "17 - unused"  \
		      "18 - unused"  \
		      "19 - VME"     \
		      "20 - PCI"  \
		      "21 - Neutron Wall"  \
		      "22 - unused"  \
                      "23 - unused"  \
		      "24 - unused"  \
	              "25 - unused"  \
		      "26 - unused"  \
		      "27 - unused"  \
		      "28 - unused"  \
		      "29 - unused"  \
		      "30 - unused"  \
		      "31 - unused"  \
		      "32 - unused"  \
                      "33 - unused"  \
		      "34 - unused"  \
	              "35 - unused"  \
		      "36 - unused"  \
		      "37 - unused"  \
		      "38 - unused"  \
		      "39 - unused"  \
		      "40 - Acquistion Command Serveur"  \
		      "41 - Surveyor"  \
		      "42 - Exogam D2VB"  \
                      "43 - Exogam Output"]

set levelnames  [list "0 - Zero"  \
	              "1 - Test"  \
	              "2 - Debug"  \
		      "3 - Information"  \
		      "4 - Warning"  \
	              "5 - Error"  \
		      "6 - Alarm"  \
		      "7 - Fault"  \
		      "8 - Failure"  \
		      "9 - Actions"]

set hostlist {}
set resources(NULL) null
set resource null

set aliases(NULL) null

#    check for existance of exception monitor file and obtain current size
proc probe_xm_file {} {
   global xmstatus xmdirectory xmfile xmsize
   set xmstatus 0
   if {![file isdirectory $xmdirectory]} then {
        midas-warning "Unable to access directory $xmdirectory"
        return 0
   }
   set xmstatus 1
   set file [clock format [clock seconds] -format %d%b%y]
   if {$file != $xmfile} then {
       set xmfile $file
       set xmsize 0
       :modify LIST :strings  "file is [file join $xmdirectory $xmfile]\n"
   }
   set f [file join $xmdirectory $xmfile]
   if {![file exists $f]} then {
#    expected file does not exist - this may be OK  (just no messages)
      return 0
   }
   set xmstatus 2
   if {![file readable $f]} then {
       midas-warning "Unable to read file $f"
       set xmstatus 1
       return 0
   }
   return [file size $f]
}

proc check_xm_file {} {
   global xmstatus xmsize xmperiod xmdirectory xmfile

   set size [probe_xm_file]
   if {$size > $xmsize} then {
      set f [file join $xmdirectory $xmfile]

      set z [catch {open $f} h]
      if {$z == 0} then {
         seek $h $xmsize
         exceptions [read $h]
      } else {
         set-footer "read error - $h"
      }
      close $h
   }
   set xmsize $size
   if {$xmstatus > 0} then {after $xmperiod check_xm_file}
clear-footer
}       

proc make-frame {} {
   global env min max
   global classnames levelnames ActionEnable

set rows 12
set cols 80

   :frame [self frame-name] :label "[self frame-title]" \
     :icon-name "[self icon-title]" \
     :icon-image "@$env(ICONHOME)/xmonitor" 

   :panel C1 :layout L :padx 5 :pady 5
   :layout H; :row-gap 10; :col-gap 10

     :choice-stack MIN :label "Minimum Level:" :valuex 150 :value $min :strings $levelnames
     :next-row T

     :choice-stack MAX :label "Maximum Level:" :valuex 150 :value $max :strings $levelnames
     :next-row T

     :checkbox ACTIONS :label "Enable Actions?" :valuex 150 :value $ActionEnable
     :next-row T

     :button SAVE
     :button PRINT
     :button CLEAR  :label "Clear Display"  :command ":modify LIST :empty T"
     :hskip 50
     :button HELP   :command click-help

   :panel C2 :layout R :padx 5 :pady 5
   :layout H

     :message M1 :label "Classes:"  :bold T
     :list CLASS :cols 24 :rows 7 :exclusive F :strings $classnames

   :panel C3 :layout B :padx 5 :pady 5 :after FOOTER

     :galley LIST :cols $cols :rows $rows :deaf T  :font variable

     :show T

  :galley_size LIST $rows $cols
}

proc click-configure {W} {:galley_resize LIST}
proc click-save  {} {midas-browser W midas-save-window [:path LIST].text}
proc click-print {} {midas-print-window [:path LIST].text}

proc make-hostlist {} {
    global hostlist resources aliases
     set z [catch {eg "(experiment ?resources)"} r]
     if {$z != 0} then {set r {}}
     set s {}
     foreach resource  $r {
         foreach p $resource {
            switch [first $p]  {
               host       {if {[lsearch $s [second $p]] < 0} then {
                              set host [second $p]
                              if {[info exists aliases($host)]} then {set host $aliases($host)}
                              lappend s $host
                              set resources($host) $name
                           }
               }
               name       {set name [second $p]}
               default    {}
            }
         }
     }
     if {$s != $hostlist} then {
        set hostlist $s
        if {$hostlist == ""} then {
           :modify LIST :strings "no servers connected\n"
        } else {
           :modify LIST :strings "monitoring hosts $hostlist\n"
        }
     }
}

proc exceptions text {
   global started ActionEnable ActionLevel selected min max hostlist maxclass maxlevel
   if {$started==1} then {
      make-hostlist
      set lines [split $text \n]
      foreach line $lines {
         if {$line == ""} then {continue}
         set class [second $line]
         if {$class > $maxclass} then {continue}
         set level [third $line]
         if {$level > $maxlevel} then {continue}
         set host [fourth $line]
         if {[lsearch $hostlist $host] >= 0 && $selected($class) == 1 && $level >= $min && $level <= $max} then {
            OpenIt
            :modify LIST :strings "$line\n"
            if {$level == $ActionLevel && $ActionEnable != 0} then {Action "$line"}
         }
      }
   }
}

proc click-list {c} {
	global debug selected maxclass
	if {$debug} then {puts stderr "click-list $c"}
        for {set i 0} {$i <= $maxclass} {incr i} {set selected($i) 0}
        foreach i $c {set selected($i) 1}
}

proc click-min v {
	global min max
	set min $v
	if {$max<$min} then {
		set max $min
                :modify MAX :value $max
	}
}

proc click-max v {
	global min max
	set max $v
	if {$max<$min} then {
		set min $max
                :modify MIN :value $min
	}
}

proc click arg {
	global debug ActionEnable
	if {$debug} then {insert-debug "click with argument \{$arg\}"}
	set f [lindex $arg 0]
	set c [lindex $arg 1]
	set w [lindex $arg 2]
	set v [lindex $arg 3]
	switch $w {
		CLASS   {click-list [lindex $arg 4]}
                ACTIONS {set ActionEnable $v}
		MIN     {click-min $v}
		MAX     {click-max $v}
		SAVE    {click-save}
                PRINT   {click-print}
		default {puts stdout $arg}
	}
}

proc start args {
   global started xmsize xmstatus xmperiod
   if {$started == 0} then {
      make-frame
      set started 1
      make-hostlist
      set xmsize [probe_xm_file]
      if {$xmstatus > 0} then {after $xmperiod check_xm_file}
   } else {
      centre-frame
   }
}

proc start_closed args {start; close-frame}

proc set-experiment args {
    global started
    if {$started == 1} then {make-hostlist}
}

proc unset-experiment args {
    global started
    if {$started == 1} then {make-hostlist}
}

proc OpenIt {} {
    global OpenPending

    if {[wm state .] != "normal"} then {open-frame}
    if {$OpenPending != ""} then {after cancel $OpenPending}
    set OpenPending [after 1000 DoOpenIt]
}

proc DoOpenIt {} {
    global OpenPending

    set OpenPending ""
    open-frame
}

proc Action {text} {
   global resource resources
   set m [split $text #]
   if {[second $m] == "message" && [fourth $m] == "action"} then {
#    correctly formatted action 

      set source [fourth [first $m]]
      set resource $resources($source)
      set message [third $m]
      set action [fifth $m]

      insert-log "[date] Message received from $source: text - $message; action - $action"

      set z [catch {eval $action} result]
      if {$result != ""} then {insert-log "Action result: $result"} else {insert-log "Action complete"}
   }
}


proc execute {file args} {
    global parameters
    set parameters $args
    if {[loadsource $file] == 0} then {return "file $file not found"}
    return "Action completed"
}
